package com.yizhi.aliyun.application.controller;

import com.yizhi.aliyun.application.util.PropertiesUtil;
import com.yizhi.core.application.file.util.MinioTools;
import com.yizhi.util.application.domain.Response;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.time.DateFormatUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.multipart.support.StandardServletMultipartResolver;
import org.springframework.web.servlet.support.ServletUriComponentsBuilder;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Date;

@RestController
@Slf4j
@RequestMapping("/api")
public class FileUploadController {

    @Autowired
    private MinioTools minioTools;

    @Autowired
    PropertiesUtil propertiesUtil;

    @Value("${pc.host.url}")
    String pcHostUrl;
 
    @PostMapping("/upload")
    public Response<String> uploadFile() {
        try {
            HttpServletRequest httpRequest = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
            StandardServletMultipartResolver resolver = new StandardServletMultipartResolver();
            MultipartHttpServletRequest multipartRequest = resolver.resolveMultipart(httpRequest);
            MultipartFile file = multipartRequest.getFile("file");
            String bucketName =propertiesUtil.getPublicParam().get("ossdir");;
            String name = file.getOriginalFilename();
            String[] fileNames = name.split("\\.");
            name = fileNames[0] + DateFormatUtils.format(new Date(), "yyyyMMdd") + fileNames[1];
            log.info("=============文件大小：{}===========",file.getSize());
            minioTools.uplodFile(bucketName,name,file.getInputStream());
            return Response.ok(pcHostUrl+"/api/v1/buckets/"+bucketName+"/objects/download/?preview=true&prefix="+name);
        } catch (IOException ex) {
            return Response.fail("Could not upload the file ");
        }
    }
}